<template>
  <div>
    <div class="realmap-wrapper">
      <button
        @click.stop="openMap"
        class="map-btn map-btn--fullscreen pointer"
        aria-label="zoom"
      ></button>
      <real-map
        :image="image"
        :center="restaurants[0].realMapPosition"
        :restaurants="restaurants"
      />
      <modal v-if="opened" @close="opened = false">
        <real-map
          :scroll="true"
          @center="center = null"
          :image="image"
          :center="center"
          :restaurants="restaurants"
        />
        <button
          class="map-btn map-btn--locate pointer"
          @click="locate"
          aria-label="locate"
        ></button>
      </modal>
    </div>
    <dl class="info-list reset-list">
      <dt>{{ $t("restaurant.location") }}</dt>
      <dd>{{ buildingAddress }}</dd>
      <dt>{{ $t("restaurant.type") }}</dt>
      <dd>{{ $t(`restaurantTypes.${restaurant.restaurantType}`) }}</dd>
      <template v-if="restaurant.minimumCharge">
        <dt>{{ $t("restaurant.minimumCharge") }}</dt>
        <dd
          v-html="
            restaurant.minimumCharge.replace(/(?:\r\n|\r|\\n)/g, '<br />')
          "
        ></dd>
      </template>
      <dt>{{ $t("restaurant.phone") }}</dt>
      <dd>
        <a :href="`tel:${restaurant.phoneNumber}`">{{
          restaurant.phoneNumber
        }}</a>
      </dd>
      <dt v-if="restaurant.openingTimes.length">
        {{ $t("restaurant.openingTime") }}
      </dt>
      <dd v-if="restaurant.openingTimes.length">
        <ul class="reset-list">
          <li v-for="t in restaurant.openingTimes">{{ t.from }}-{{ t.to }}</li>
        </ul>
      </dd>
    </dl>
  </div>
</template>

<script>
import realmap from "@/const/realmap";
import Modal from "@/components/Modal";
import RealMap from "@/components/Group/RealMap";

export default {
  props: {
    image: {
      type: String
    },
    restaurants: {
      type: Array
    }
  },

  data() {
    return {
      opened: false,
      center: this.restaurants[0].realMapPosition
    };
  },

  components: {
    Modal,
    RealMap
  },

  computed: {
    realmap() {
      return realmap;
    },

    restaurant() {
      return this.restaurants[0];
    },

    buildingAddress() {
      return this.restaurant.buildingAddress;
    }
  },

  methods: {
    openMap() {
      this.opened = true;
    },

    locate() {
      this.center = this.restaurants[0].realMapPosition;
    }
  }
};
</script>

<style lang="scss" scoped>
.realmap-wrapper {
  position: relative;
  width: 100%;
  padding-bottom: 72.7%;
}

.map-btn {
  z-index: 1;
  width: 40px;
  height: 40px;
  border: none;
  border-radius: 3px;
  box-shadow: 0 2px 3px 2px rgba($color-secondary-black, 0.3);

  &--locate {
    position: fixed;
    right: 10px;
    bottom: 10px;
    background: $color-white url("/static/images/ic-locate.svg") center/contain
      no-repeat;

    @include media-breakpoint-up(md) {
      transform: scale(1.5);
      right: 50px;
      bottom: 50px;
    }
  }

  &--fullscreen {
    position: absolute;
    right: 20px;
    bottom: 20px;
    background: $color-white url("/static/images/ic-fullscreen.svg")
      center/contain no-repeat;
    transition: all 0.3s;

    &:hover,
    &:active {
      transform: scale(0.9);
    }
  }
}

.info-list {
  padding: 0 0 0$grid-gutter-width * 1.5;

  dt {
    font-weight: 500;
    color: $color-primary-black;
    padding-top: $grid-gutter-width/2;
    margin-bottom: $grid-gutter-width/4;
  }

  dd + dt {
    border-top: 1px solid $color-silver-grey;
    margin-top: $grid-gutter-width/2;
  }

  dd {
    padding-right: $grid-gutter-width * 1.5;
    color: $color-secondary-black;
  }

  dd:last-child {
    padding-bottom: $grid-gutter-width;
  }
}
</style>
